Option Explicit
'On Error Resume Next

Dim rs1
Dim FileName1
Dim dbConn1
Dim rs
Dim rsGENRE
Dim rsBitrate
Dim dbConn
Dim Action
Dim FileName 
Dim RadioName
Dim RadioBitRate
Dim RadioGenre
Dim RadioMedia
Dim RadioMedia1
Dim Data
Dim SelStation
Dim StationIDNo

FileName   = "C:\Program Files\HouseBot\Config\DATA\RADIOSTATIONS.mdb"
Set dbConn = CreateObject( "ADODB.Connection" ) 
dbConn.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & FileName

'===============================================================================================
'Continuous running script
Do
	Sleep 1
	Action = GetPropertyValue("RadioStations.Action")	
		If Action <> "Waiting" Then
		SetPropertyValue "RadioStations.Action", "Waiting"
		Call Handle_RadioStationAction(Action)
		Sleep 50
	End If
Loop

' Reset
Set rs       = Nothing
Set FileName = Nothing
Set dbConn   = Nothing
 
'======================================================================================================
Sub Handle_RadioStationAction(Action)

	
	Data = Split(Action, "^")
	Select Case Data(0)
		Case "UPD"  : Call Update
		Case "Radio_List"  : Call LIST_RADIO
		Case "BitRate_List"  : Call LIST_BITRATE
		Case "Genre_List" : Call LIST_GENRE
		Case "Radio": Call SelRadioStations(Data(1))
		Case "StationEnter" : Call SelectStationSUB
		Case "Genre" : Call PANELchangeGENRE(Data(1))
		Case "BitRate" : Call PANELchangeBitRate(Data(1))
		End Select

	End Sub
 '======================================================================================================
Sub Update

	FileName1   = "C:\Program Files\HouseBot\Config\HBData.mdb"
	Set dbConn1 = CreateObject( "ADODB.Connection" ) 
	dbConn1.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & FileName1

	Set rs1 = dbConn1.Execute("DELETE FROM AlphaList WHERE ListData LIKE 'Radio^%'")
	Set rs1 = dbConn1.Execute("DELETE FROM AlphaList WHERE ListData LIKE 'Genre^%'")
	Set rs1 = dbConn1.Execute("DELETE FROM AlphaList WHERE ListData LIKE 'Media^%'")
	Set rs1 = dbConn1.Execute("DELETE FROM AlphaList WHERE ListData LIKE 'BitRate^%'")
	SetPropertyValue "RadioStations.SORT LABEL", "PLEASE WAIT AS STATIONS ARE UPDATED"
	SetPropertyValue "RadioStations.StationName", "Updating Station Names......"
	SetPropertyValue "RadioStations.BitRate", "Updating......."
	SetPropertyValue "RadioStations.Genre", "Updating Genre......."
	SetPropertyValue "RadioStations.MediaType", "NO DATA YET......."
	SetPropertyValue "RadioStations.Sublist", "Updating Station Names......"
	
	Set rs1 = Nothing
	Set FileName1 = Nothing
	Set dbConn1 = Nothing

'=====================================
	'Populates the RadioStationsGenre List fields.
	Set rs = dbConn.Execute( "SELECT [CompleteGenre] FROM QueryGenreDistinct")
	Do
	RadioGenre = RadioGenre & "Genre^" &  rs("CompleteGenre") &  vbTab & rs("CompleteGenre") & vbLF
	rs.MoveNext
	Loop Until rs.EOF
	Set rs = Nothing
	SetPropertyValue "RadioStations.Genre", RadioGenre

'=====================================
	'Populates the RadioStationsMediaType List fields.
	Set rs = dbConn.Execute( "SELECT [MediaType] FROM QueryMedia")
	Do 
	RadioMedia = RadioMedia & "Media^" &  rs("MediaType") &  vbTab & rs("MediaType") & vbLF
	rs.MoveNext
	Loop Until rs.EOF
	Set rs = Nothing
	SetPropertyValue "RadioStations.MediaType", RadioMedia

'=====================================
	'Populates the RadioStationsBitrate List fields.
	Set rs = dbConn.Execute( "SELECT [BitRate] FROM QueryBitrate")
	Do
	RadioBitRate = RadioBitRate & "BitRate^" &  rs("BitRate") &  vbTab & rs("BitRate") & vbLF
	rs.MoveNext
	Loop Until rs.EOF
	Set rs = Nothing
	SetPropertyValue "RadioStations.BitRate", RadioBitRate
	
'=====================================
	'Populates the RadioStationsName List fields.
	Set rs = dbConn.Execute( "SELECT [StationName] FROM QueryName")
	Do
	RadioName = RadioName & "Radio^" &  rs("StationName") &  vbTab & rs("StationName") & vbLF
	rs.MoveNext
	Loop Until rs.EOF
	Set rs = Nothing
	SetPropertyValue "RadioStations.StationName", RadioName
	SetPropertyValue "RadioStations.Sublist", RadioName
	SetPropertyValue "RadioStations.SORT LABEL", "SELECT A STATION NAME"
	End Sub
'======================================
Sub SelRadioStations(Data)
	Set rs = dbConn.Execute("SELECT StationName, Genre, MediaType, StationID, BitRate FROM [COMPLETESTATIONS] WHERE StationName = '" & Data & "'")
	SetPropertyValue "RadioStations.Selected Bitrate", rs("BitRate")
	SetPropertyValue "RadioStations.Selected Genre", rs("Genre")
	SetPropertyValue "RadioStations.Selected MediaType", rs("MediaType")
	SetPropertyValue "RadioStations.Selected Station", rs("StationName")	
	SetPropertyValue "RadioStations.StationID", rs("StationID")
	StationIDNo = GetPropertyValue("RadioStations.StationID")
	StationIDNo = "http://yp.shoutcast.com/sbin/tunein-station.pls?id=" & StationIDNo
	SetPropertyValue "RadioStations.TotalURL", StationIDNo
	
	Set rs = Nothing
	End Sub
'=======================================
Sub SelectStationSUB
	
	SetPropertyValue "WINAMP_CONTROLS.Currently Active Play List", "Play List 2"
	SetPropertyValue "WINAMP_CONTROLS.Play List 2", StationIDNo
	SetPropertyValue "WINAMP_CONTROLS.A/V Status", "Playing"
	End Sub
'===============
'When "GENRE" is in the property change button it switches the list box (SubList)
Sub LIST_GENRE
	Dim StGenre
	StGenre = GetPropertyValue("RadioStations.Genre")
	SetPropertyValue "RadioStations.Sublist", StGenre
	SetPropertyValue "RadioStations.SORT LABEL", "SELECT A GENRE"
	End Sub
'===============
Sub PANELchangeGENRE(Data)
	Dim PLGNre
	SetPropertyValue "RadioStations.SORT LABEL", Data & " GENRE STATIONS"
	SetPropertyValue "RadioStations.Sublist", "UPDATING  TO  THE  " & Data & "  GENRE"
	Set rsGenre = dbConn.Execute("SELECT DISTINCT StationNm FROM [QueryCompleteGenre] WHERE (CompleteGenre) IN ('" & Data & "') ORDER BY StationNm")
	Do
	PLGNre = PLGNre & "Radio^" & rsGenre("StationNm") &  vbTab & rsGenre("StationNm") & vbLF
	rsGenre.MoveNext
	Loop Until rsGenre.EOF
	Set rsGenre = Nothing
	SetPropertyValue "RadioStations.Sublist", PLGNre
	End Sub
'=========================
'When "BITRATE" is in the property change button it switches the list box (SubList)
Sub LIST_BITRATE
	Dim StBitRate
	StBitRate = GetPropertyValue("RadioStations.BitRate")
	SetPropertyValue "RadioStations.Sublist", StBitRate
	SetPropertyValue "RadioStations.SORT LABEL", "SELECT A BITRATE"
	End Sub
'========================
Sub PANELchangeBitRate(Data)
	Dim PLBitRate
	SetPropertyValue "RadioStations.SORT LABEL", Data & " BITRATE STATIONS"
	SetPropertyValue "RadioStations.Sublist", "UPDATING  TO  THE  " & Data & "  BITRATE"
	Set rsBitrate = dbConn.Execute("SELECT DISTINCT StationNm FROM [QueryCompleteGenre] WHERE (Quality) IN (" & Data & ") ORDER BY StationNm")
	Do
	PLBitRate = PLBitRate & "Radio^" & rsBitrate("StationNm") &  vbTab & rsBitrate("StationNm") & vbLF
	rsBitrate.MoveNext
	Loop Until rsBitrate.EOF
	Set rsBitrate = Nothing
	SetPropertyValue "RadioStations.Sublist", PLBitRate
	
	End Sub
'=================
'When "Radio" is in the property change button it switches the list box (SubList)

Sub LIST_RADIO
	Dim StRadio
	StRadio = GetPropertyValue("RadioStations.StationName")
	SetPropertyValue "RadioStations.Sublist", StRadio
	SetPropertyValue "RadioStations.SORT LABEL", "SELECT A STATION NAME"
	End Sub